### Function

# Dex StateTransitionFunc

#### Declaration

    gboolean
    (* DexStateTransitionFunc) (
      DexStateTransitionContext* context,
      gpointer user_data,
      GError** error
    )

#### Description [src]

Callback used to execute a transition edge.

`context` is opaque and only valid for the duration of the callback. It must not be stored or used after the callback returns.

Use `dex_state_transition_context_get_from()` and `dex_state_transition_context_get_to()` to inspect the edge that caused the callback to run. Use `dex_state_transition_context_get_state()` and `dex_state_transition_context_set_state()` to inspect or update the real state of the `DexStateMachine` while the transition is running. Use `dex_state_transition_context_continue_to()` to continue through another declared edge before queued transition requests are processed.

#### Parameters

`context`

  Type: `DexStateTransitionContext`

  A `DexStateTransitionContext`.

  The data is owned by the caller of the function.

`user_data`

  Type: `gpointer`

  User data provided to `dex_state_machine_new()`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if the transition succeeded; otherwise `FALSE` and `error` is set.